import*as GLenum from"./gl-const.js";import{VertexStepMode}from"./type.js";export function is3DTexture(dimension){return dimension===GLenum.TEXTURE_3D||dimension===GLenum.TEXTURE_2D_ARRAY}export function indexByteSize(format){return format===GLenum.UNSIGNED_SHORT?2:4}export function vertexByteSize(format){return(format>>4&15)*vertexSize(format)}export function vertexSize(format){return format&15}export function vertexType(format){switch(format>>4&511){case 36:return GLenum.FLOAT;case 34:return GLenum.HALF_FLOAT;case 274:return GLenum.SHORT;case 273:return GLenum.BYTE;case 18:return GLenum.UNSIGNED_SHORT;case 17:return GLenum.UNSIGNED_BYTE;}return GLenum.NONE}export function vertexNormalized(format){return!!(format>>13)}export function vertexBufferLayouts(buffers){let shaderLocation=0;const result=[];for(let i=0;i<buffers.length;++i){const attributes=[];let stride=0;for(let j=0;j<buffers[i].attributes.length;++j){const format=buffers[i].attributes[j];attributes.push({format,offset:stride,shaderLocation});stride+=vertexByteSize(format);++shaderLocation}result.push({attributes,stride,stepMode:buffers[i].instanced?VertexStepMode.Instance:VertexStepMode.Vertex})}return result}export function isDepthStencil(format){switch(format){case GLenum.DEPTH_COMPONENT16:case GLenum.DEPTH_COMPONENT24:case GLenum.DEPTH24_STENCIL8:case GLenum.DEPTH_COMPONENT32F:case GLenum.DEPTH32F_STENCIL8:return true;}return false}export function hasStencil(format){switch(format){case GLenum.STENCIL_INDEX8:case GLenum.DEPTH24_STENCIL8:case GLenum.DEPTH32F_STENCIL8:return true;}return false}export function glTexelFormat(format){switch(format){case GLenum.R8:case GLenum.R8_SNORM:case GLenum.R16F:case GLenum.R32F:return GLenum.RED;case GLenum.R8UI:case GLenum.R8I:case GLenum.R16UI:case GLenum.R16I:case GLenum.R32UI:case GLenum.R32I:return GLenum.RED_INTEGER;case GLenum.RG8:case GLenum.RG8_SNORM:case GLenum.RG16F:case GLenum.RG32F:return GLenum.RG;case GLenum.RG8UI:case GLenum.RG8I:case GLenum.RG16UI:case GLenum.RG16I:case GLenum.RG32UI:case GLenum.RG32I:return GLenum.RG_INTEGER;case GLenum.RGBA8:case GLenum.SRGB8_ALPHA8:case GLenum.RGBA8_SNORM:case GLenum.RGB10_A2:case GLenum.RGBA16F:case GLenum.RGBA32F:return GLenum.RGBA;case GLenum.RGBA8UI:case GLenum.RGBA8I:case GLenum.RGBA16UI:case GLenum.RGBA32UI:case GLenum.RGBA16I:case GLenum.RGBA32I:return GLenum.RGBA_INTEGER;case GLenum.R11F_G11F_B10F:return GLenum.RGB;case GLenum.DEPTH_COMPONENT16:case GLenum.DEPTH_COMPONENT24:case GLenum.DEPTH_COMPONENT32F:return GLenum.DEPTH_COMPONENT;case GLenum.DEPTH24_STENCIL8:case GLenum.DEPTH32F_STENCIL8:return GLenum.DEPTH_STENCIL;}return GLenum.NONE}export function glTexelSize(format){switch(format){case GLenum.R8:case GLenum.R8UI:case GLenum.R8_SNORM:case GLenum.R8I:return 1;case GLenum.R16UI:case GLenum.R16I:case GLenum.RG8:case GLenum.RG8UI:case GLenum.RG8_SNORM:case GLenum.RG8I:case GLenum.R16F:return 2;case GLenum.R32UI:case GLenum.R32I:case GLenum.R32F:case GLenum.RG16UI:case GLenum.RG16I:case GLenum.RG16F:case GLenum.RGBA8:case GLenum.SRGB8_ALPHA8:case GLenum.RGBA8UI:case GLenum.RGBA8_SNORM:case GLenum.RGBA8I:case GLenum.RGB10_A2:case GLenum.R11F_G11F_B10F:return 4;case GLenum.RG32UI:case GLenum.RG32I:case GLenum.RG32F:case GLenum.RGBA16UI:case GLenum.RGBA16I:case GLenum.RGBA16F:return 8;case GLenum.RGBA32UI:case GLenum.RGBA32I:case GLenum.RGBA32F:return 16;case GLenum.DEPTH_COMPONENT16:return 2;case GLenum.DEPTH_COMPONENT24:case GLenum.DEPTH24_STENCIL8:case GLenum.DEPTH_COMPONENT32F:return 4;case GLenum.DEPTH32F_STENCIL8:return 8;}return 0}export function glTexelType(format){switch(format){case GLenum.R8:case GLenum.R8UI:case GLenum.RG8:case GLenum.RG8UI:case GLenum.RGBA8:case GLenum.SRGB8_ALPHA8:case GLenum.RGBA8UI:return GLenum.UNSIGNED_BYTE;case GLenum.R8_SNORM:case GLenum.R8I:case GLenum.RG8_SNORM:case GLenum.RG8I:case GLenum.RGBA8_SNORM:case GLenum.RGBA8I:return GLenum.BYTE;case GLenum.R16UI:case GLenum.RG16UI:case GLenum.RGBA16UI:return GLenum.UNSIGNED_SHORT;case GLenum.R16I:case GLenum.RG16I:case GLenum.RGBA16I:return GLenum.SHORT;case GLenum.R32UI:case GLenum.RG32UI:case GLenum.RGBA32UI:return GLenum.UNSIGNED_INT;case GLenum.R32I:case GLenum.RG32I:case GLenum.RGBA32I:return GLenum.INT;case GLenum.RGB10_A2:return GLenum.UNSIGNED_INT_2_10_10_10_REV;case GLenum.R16F:case GLenum.RG16F:case GLenum.RGBA16F:return GLenum.HALF_FLOAT;case GLenum.R32F:case GLenum.RG32F:case GLenum.RGBA32F:return GLenum.FLOAT;case GLenum.R11F_G11F_B10F:return GLenum.UNSIGNED_INT_10F_11F_11F_REV;case GLenum.DEPTH_COMPONENT16:return GLenum.UNSIGNED_SHORT;case GLenum.DEPTH_COMPONENT24:return GLenum.UNSIGNED_INT;case GLenum.DEPTH24_STENCIL8:return GLenum.UNSIGNED_INT_24_8;case GLenum.DEPTH_COMPONENT32F:return GLenum.FLOAT;case GLenum.DEPTH32F_STENCIL8:return GLenum.FLOAT_32_UNSIGNED_INT_24_8_REV;}return GLenum.NONE}export function glClearType(format){switch(format){case GLenum.R8I:case GLenum.R16I:case GLenum.R32I:case GLenum.RG8I:case GLenum.RG16I:case GLenum.RG32I:case GLenum.RGBA8I:case GLenum.RGBA16I:case GLenum.RGBA32I:return GLenum.INT;case GLenum.R8UI:case GLenum.R16UI:case GLenum.R32UI:case GLenum.RG8UI:case GLenum.RG16UI:case GLenum.RG32UI:case GLenum.RGBA8UI:case GLenum.RGBA16UI:case GLenum.RGBA32UI:return GLenum.UNSIGNED_INT;}return GLenum.FLOAT}
//# sourceMappingURL=gl-util.js.map